//------------------------------------------------------------------

   #property copyright "mladen"
   #property link      "www.forex-tsd.com"
   
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  DeepSkyBlue
#property indicator_width1  2
#property indicator_color2  PaleVioletRed
#property indicator_width2  2
#property indicator_color3  PaleVioletRed
#property indicator_width3  2
#property indicator_color4  Gold
#property indicator_width4  2

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame      = PERIOD_CURRENT;
extern int             ROCPeriod1     = 14;
extern int             ROCPeriod2     = 10;
extern int             Smooth         = 11;
extern int             Signal         = 5;
extern ENUM_MA_METHOD  SignalMethod   = MODE_SMA;

//
//
//
//
//

double osc[];
double oscda[];
double oscdb[];
double signal[];
double slope[];

//---------------------------MTF-------------------------------------
string TF,IndicatorName;


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
      IndicatorBuffers(5);
      SetIndexBuffer(0,osc);    SetIndexLabel(0,"Coppock curve");
      SetIndexBuffer(1,oscda);  SetIndexLabel(1,"Coppock curve");
      SetIndexBuffer(2,oscdb);  SetIndexLabel(2,"Coppock curve"); 
      SetIndexBuffer(3,signal); SetIndexLabel(3,"Coppock curve signal");
      SetIndexBuffer(4,slope);
   IndicatorShortName(" Coppock curve "+" ("+ROCPeriod1+","+ROCPeriod2+","+Smooth+","+Signal+")");
   
   
//---------------------------MTF-------------------------------------
   switch(TimeFrame)
   {
      case 1:     string TimeFrameStr ="M1";  break;
      case 5:     TimeFrameStr ="M5";         break;
      case 15:    TimeFrameStr ="M15";        break;
      case 30:    TimeFrameStr ="M30";        break;
      case 60:    TimeFrameStr ="H1";         break;
      case 240:   TimeFrameStr ="H4";         break;
      case 1440:  TimeFrameStr ="D1";         break;
      case 10080: TimeFrameStr ="W1";         break;
      case 43200: TimeFrameStr ="MN1";        break;
      default:    TimeFrameStr ="Current";
   }
   IndicatorName = WindowExpertName();
         TimeFrame = MathMax(TimeFrame,_Period);
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(MathMax(Bars-counted_bars,3*TimeFrame/_Period),Bars-1);
           if (slope[limit] == -1) CleanPoint(limit,oscda,oscdb);
      
      //
      //
//---------------------------MTF-------------------------------------
   if(TimeFrame != Period())
	{
   limit = MathMax(limit,TimeFrame/Period());
      for(int shift=0; shift<limit; shift++)
      {	
      int y = iBarShift(NULL,TimeFrame,Time[shift]);
      osc[shift]    = iCustom(NULL,TimeFrame,IndicatorName,0,ROCPeriod1,ROCPeriod2,Smooth,Signal,SignalMethod,0,y);
      oscda[shift]  = iCustom(NULL,TimeFrame,IndicatorName,0,ROCPeriod1,ROCPeriod2,Smooth,Signal,SignalMethod,1,y);
      oscdb[shift]  = iCustom(NULL,TimeFrame,IndicatorName,0,ROCPeriod1,ROCPeriod2,Smooth,Signal,SignalMethod,2,y);
      signal[shift] = iCustom(NULL,TimeFrame,IndicatorName,0,ROCPeriod1,ROCPeriod2,Smooth,Signal,SignalMethod,3,y);
      slope[shift]  = iCustom(NULL,TimeFrame,IndicatorName,0,ROCPeriod1,ROCPeriod2,Smooth,Signal,SignalMethod,4,y);
      }
   return(0);
   }
//------------------------------------------------------------------
      //
      //
      
      for (int i=limit;i>=0;i--)
      {
         osc[i]   = iLwma(iROC(ROCPeriod1,i)+iROC(ROCPeriod2,i),Smooth,i,0);
         oscda[i] = EMPTY_VALUE;
         oscdb[i] = EMPTY_VALUE;
         slope[i] = slope[i+1];
         if (osc[i] > osc[i+1]) slope[i] =  1;
         if (osc[i] < osc[i+1]) slope[i] = -1;
         if (slope[i] == -1) PlotPoint(i,oscda,oscdb,osc);      
      }
      if (Signal>1) for (i=limit; i>=0; i--) signal[i] = iMAOnArray(osc,0,Signal,0,SignalMethod,i);
return(0);
}      

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workLwma[][1];
double iLwma(double price, double period, int r, int instanceNo=0)
{
   if (ArraySize(workLwma)!= Bars) ArrayResize(workLwma,Bars); r = Bars-r-1;
   
   //
   //
   //
   //
   //
   
   workLwma[r][instanceNo] = price;
      double sumw = period;
      double sum  = period*price;

      for(int k=1; k<period && (r-k)>=0; k++)
      {
         double weight = period-k;
                sumw  += weight;
                sum   += weight*workLwma[r-k][instanceNo];  
      }             
return(sum/sumw);
}

//
//
//
//
//

double iROC(int period, int shift)
{
   double ROC;

   if (Close[shift + period] != 0)
          ROC = (Close[shift]-Close[shift + period]) / Close[shift + period];
   else   ROC = 0.00;
   return(ROC*100.00);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}


//---------------------------MTF-------------------------------------
string tf(int timeframe)
{
   switch(timeframe)
   {
   case 0:     return("M1");
   case 5:     return("M5");
   case 15:    return("M15");
   case 30:    return("M30");
   case 60:    return("H1");
   case 240:   return("H4");
   case 1440:  return("D1");
   case 10080: return("W1");
   case 43200: return("MN1");
   default:    return("Current");
   }
}
//------------------------------------------------------------------